# this file contains all the string data (inputs and outputs) for tests

# the SD trees were originally produced on SD 3.4.1 but they work up
# to (at least) SD 3.5.2. the UD trees were produced using UD 3.5.2.
# tests now require SD/UD 3.5.2 (and thus Java 1.8). downside of this
# is that we can't test JPype on older versions of SD since it can only
# be (safely) initialized once.

class trees_sd:
    tree1 = '(S1 (NP (DT a) (NN cow)))'
    tree1_out = '''
Token(index=1, form='a', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='cow', cpos='NN', pos='NN', head=0, deprel='root')
    '''.strip()

    tree2 = '(S1 (NP (NP (NP (DT A) (NN cat)) (CC and) (NP (DT a) ' \
            '(NN mouse))) (. .)))'
    tree2_out_basic = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='cat', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='a', cpos='DT', pos='DT', head=5, deprel='det')
Token(index=5, form='mouse', cpos='NN', pos='NN', head=2, deprel='conj')
Token(index=6, form='.', cpos='.', pos='.', head=2, deprel='punct')'''.strip()
    tree2_out_collapsed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='cat', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=4, form='a', cpos='DT', pos='DT', head=5, deprel='det')
Token(index=5, form='mouse', cpos='NN', pos='NN', head=2, deprel='conj_and')
Token(index=6, form='.', cpos='.', pos='.', head=2, deprel='punct')'''.strip()
    tree2_out_CCprocessed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='cat', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=4, form='a', cpos='DT', pos='DT', head=5, deprel='det')
Token(index=5, form='mouse', cpos='NN', pos='NN', head=2, deprel='conj_and')
Token(index=6, form='.', cpos='.', pos='.', head=2, deprel='punct')'''.strip()
    tree2_out_collapsedTree = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='cat', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=4, form='a', cpos='DT', pos='DT', head=5, deprel='det')
Token(index=5, form='mouse', cpos='NN', pos='NN', head=2, deprel='conj_and')
Token(index=6, form='.', cpos='.', pos='.', head=2, deprel='punct')'''.strip()

    tree3 = '(S1 (NP (DT some) (JJ blue) (NN moose)))'
    tree3_out = '''
Token(index=1, form='some', cpos='DT', pos='DT', head=3, deprel='det')
Token(index=2, form='blue', cpos='JJ', pos='JJ', head=3, deprel='amod')
Token(index=3, form='moose', cpos='NN', pos='NN', head=0, deprel='root')
    '''.strip()

    tree4 = '(S1 (NP (NP (DT A) (NN burrito)) (PP (IN with) (NP (NP ' + \
            '(NNS beans)) (CONJP (CC but) (RB not)) (NP (NN chicken)))) (. .)))'
    tree4_out_basic = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=3, form='with', cpos='IN', pos='IN', head=2, deprel='prep')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=3, deprel='pobj')
Token(index=5, form='but', cpos='CC', pos='CC', head=6, deprel='cc')
Token(index=6, form='not', cpos='RB', pos='RB', head=4, deprel='cc')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree4_out_collapsed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=2, deprel='prep_with')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj_negcc')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree4_out_CCprocessed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=2, deprel='prep_with')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=2, deprel='prep_with')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj_negcc')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree4_out_collapsedTree = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=2, deprel='prep_with')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj_negcc')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()

    tree5 = '''
    (S1 (S (NP (NNP Ed))
         (VP (VBZ cooks)
          (CC and)
          (VBZ sells)
          (NP (NP (NNS burritos))
           (PP (IN with)
        (NP (NNS beans) (CONJP (CC but) (RB not)) (NN rice)))))
         (. .)))
    '''.strip()
    tree5_out_basic = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=5, deprel='prep')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=6, deprel='pobj')
Token(index=8, form='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_collapsed = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj_and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='prep_with')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj_negcc')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_CCprocessed = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=4, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj_and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='prep_with')
Token(index=10, form='rice', cpos='NN', pos='NN', head=5, deprel='prep_with')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj_negcc')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_collapsedTree = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj_and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='prep_with')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj_negcc')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_collapsedTree_no_punct = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj_and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='prep_with')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj_negcc')
    '''.strip()
    tree5_out_collapsedTree_erased = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=0, deprel='erased')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj_and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=0, deprel='erased')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='prep_with')
Token(index=8, form='but', cpos='CC', pos='CC', head=0, deprel='erased')
Token(index=9, form='not', cpos='RB', pos='RB', head=0, deprel='erased')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj_negcc')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_collapsedTree_erased_no_punct = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=0, deprel='erased')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj_and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=0, deprel='erased')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='prep_with')
Token(index=8, form='but', cpos='CC', pos='CC', head=0, deprel='erased')
Token(index=9, form='not', cpos='RB', pos='RB', head=0, deprel='erased')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj_negcc')
    '''.strip()
    tree5_out_basic_lemmas = '''
Token(index=1, form='Ed', lemma='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', lemma='cook', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', lemma='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', lemma='sell', cpos='VBZ', pos='VBZ', head=2, deprel='conj')
Token(index=5, form='burritos', lemma='burrito', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', lemma='with', cpos='IN', pos='IN', head=5, deprel='prep')
Token(index=7, form='beans', lemma='bean', cpos='NNS', pos='NNS', head=6, deprel='pobj')
Token(index=8, form='but', lemma='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', lemma='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', lemma='rice', cpos='NN', pos='NN', head=7, deprel='conj')
Token(index=11, form='.', lemma='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()

    # tests -NONE- handling
    tree6 = '''
( (S 
    (S-TPC-1 
      (NP-SBJ (PRP He) )
      (ADVP (RB also) )
      (VP (VBZ is) 
        (NP-PRD (DT a) (NN consensus) (NN manager) )))
    (, ,) 
    (NP-SBJ (NNS insiders) )
    (VP (VBP say) 
      (SBAR (-NONE- 0) 
        (S (-NONE- *T*-1) )))
    (. .) ))
    '''
    tree6_out = '''
Token(index=1, form='He', cpos='PRP', pos='PRP', head=6, deprel='nsubj')
Token(index=2, form='also', cpos='RB', pos='RB', head=6, deprel='advmod')
Token(index=3, form='is', cpos='VBZ', pos='VBZ', head=6, deprel='cop')
Token(index=4, form='a', cpos='DT', pos='DT', head=6, deprel='det')
Token(index=5, form='consensus', cpos='NN', pos='NN', head=6, deprel='nn')
Token(index=6, form='manager', cpos='NN', pos='NN', head=9, deprel='ccomp')
Token(index=7, form=',', cpos=',', pos=',', head=9, deprel='punct')
Token(index=8, form='insiders', cpos='NNS', pos='NNS', head=9, deprel='nsubj')
Token(index=9, form='say', cpos='VBP', pos='VBP', head=0, deprel='root')
Token(index=10, form='.', cpos='.', pos='.', head=9, deprel='punct')
'''.strip()

    # tests weird \/ handling
    tree7 = '''(S1 (NP 
(NP (NNP PRIME) (NNP RATE) )
(: :) 
(NP (CD 10) (CD 1\/2) (NN %) )
(. .) ))'''
    tree7_out = '''
Token(index=1, form='PRIME', cpos='NNP', pos='NNP', head=2, deprel='nn')
Token(index=2, form='RATE', cpos='NNP', pos='NNP', head=0, deprel='root')
Token(index=3, form=':', cpos=':', pos=':', head=2, deprel='punct')
Token(index=4, form='10', cpos='CD', pos='CD', head=6, deprel='num')
Token(index=5, form='1/2', cpos='CD', pos='CD', head=6, deprel='num')
Token(index=6, form='%', cpos='NN', pos='NN', head=2, deprel='dep')
Token(index=7, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()

    tree8 = '''
    (ROOT (S (NP (NNS Visitors)) (VP (MD can) (VP (VB reach) (NP (PRP it)) (ADVP (RB only)) (PP (PP (IN under) (NP (JJ strict) (JJ military) (NN escort))) (CC and) (PP (IN with) (NP (NP (JJ prior) (NN permission)) (PP (IN from) (NP (DT the) (NNP Pentagon)))))) (, ,) (PP (IN aboard) (NP (NP (JJ special) (JJ small) (NN shuttle) (NNS flights)) (SBAR (WHNP (WDT that)) (S (VP (VBP reach) (NP (DT the) (NN base)) (PP (IN by) (NP (NP (DT a) (JJ circuitous) (NN flight)) (PP (IN from) (NP (DT the) (NNP United) (NNPS States)))))))))))) (. .)))
    '''
    tree8_out = '''
Token(index=1, form='Visitors', cpos='NNS', pos='NNS', head=3, deprel='nsubj')
Token(index=2, form='can', cpos='MD', pos='MD', head=3, deprel='aux')
Token(index=3, form='reach', cpos='VB', pos='VB', head=0, deprel='root')
Token(index=4, form='it', cpos='PRP', pos='PRP', head=3, deprel='dobj')
Token(index=5, form='only', cpos='RB', pos='RB', head=3, deprel='advmod')
Token(index=6, form='under', cpos='IN', pos='IN', head=3, deprel='prep')
Token(index=7, form='strict', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=8, form='military', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=9, form='escort', cpos='NN', pos='NN', head=6, deprel='pobj')
Token(index=10, form='and', cpos='CC', pos='CC', head=6, deprel='cc')
Token(index=11, form='with', cpos='IN', pos='IN', head=6, deprel='conj')
Token(index=12, form='prior', cpos='JJ', pos='JJ', head=13, deprel='amod')
Token(index=13, form='permission', cpos='NN', pos='NN', head=11, deprel='pobj')
Token(index=14, form='from', cpos='IN', pos='IN', head=13, deprel='prep')
Token(index=15, form='the', cpos='DT', pos='DT', head=16, deprel='det')
Token(index=16, form='Pentagon', cpos='NNP', pos='NNP', head=14, deprel='pobj')
Token(index=17, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=18, form='aboard', cpos='IN', pos='IN', head=3, deprel='prep')
Token(index=19, form='special', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=20, form='small', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=21, form='shuttle', cpos='NN', pos='NN', head=22, deprel='nn')
Token(index=22, form='flights', cpos='NNS', pos='NNS', head=18, deprel='pobj')
Token(index=23, form='that', cpos='WDT', pos='WDT', head=24, deprel='nsubj')
Token(index=24, form='reach', cpos='VBP', pos='VBP', head=22, deprel='rcmod')
Token(index=25, form='the', cpos='DT', pos='DT', head=26, deprel='det')
Token(index=26, form='base', cpos='NN', pos='NN', head=24, deprel='dobj')
Token(index=27, form='by', cpos='IN', pos='IN', head=24, deprel='prep')
Token(index=28, form='a', cpos='DT', pos='DT', head=30, deprel='det')
Token(index=29, form='circuitous', cpos='JJ', pos='JJ', head=30, deprel='amod')
Token(index=30, form='flight', cpos='NN', pos='NN', head=27, deprel='pobj')
Token(index=31, form='from', cpos='IN', pos='IN', head=30, deprel='prep')
Token(index=32, form='the', cpos='DT', pos='DT', head=34, deprel='det')
Token(index=33, form='United', cpos='NNP', pos='NNP', head=34, deprel='nn')
Token(index=34, form='States', cpos='NNPS', pos='NNPS', head=31, deprel='pobj')
Token(index=35, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()
    tree8_out_collapsed = '''
Token(index=1, form='Visitors', cpos='NNS', pos='NNS', head=3, deprel='nsubj')
Token(index=2, form='can', cpos='MD', pos='MD', head=3, deprel='aux')
Token(index=3, form='reach', cpos='VB', pos='VB', head=0, deprel='root')
Token(index=3, form='reach', cpos='VB', pos='VB', head=3, deprel='conj_and', extra={'dep_is_copy': 1})
Token(index=4, form='it', cpos='PRP', pos='PRP', head=3, deprel='dobj')
Token(index=5, form='only', cpos='RB', pos='RB', head=3, deprel='advmod')
Token(index=7, form='strict', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=8, form='military', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=9, form='escort', cpos='NN', pos='NN', head=3, deprel='prep_under')
Token(index=12, form='prior', cpos='JJ', pos='JJ', head=13, deprel='amod')
Token(index=13, form='permission', cpos='NN', pos='NN', head=3, deprel='prep_with', extra={'gov_is_copy': 1})
Token(index=15, form='the', cpos='DT', pos='DT', head=16, deprel='det')
Token(index=16, form='Pentagon', cpos='NNP', pos='NNP', head=13, deprel='prep_from')
Token(index=17, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=19, form='special', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=20, form='small', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=21, form='shuttle', cpos='NN', pos='NN', head=22, deprel='nn')
Token(index=22, form='flights', cpos='NNS', pos='NNS', head=3, deprel='prep_aboard')
Token(index=22, form='flights', cpos='NNS', pos='NNS', head=24, deprel='nsubj')
Token(index=24, form='reach', cpos='VBP', pos='VBP', head=22, deprel='rcmod')
Token(index=25, form='the', cpos='DT', pos='DT', head=26, deprel='det')
Token(index=26, form='base', cpos='NN', pos='NN', head=24, deprel='dobj')
Token(index=28, form='a', cpos='DT', pos='DT', head=30, deprel='det')
Token(index=29, form='circuitous', cpos='JJ', pos='JJ', head=30, deprel='amod')
Token(index=30, form='flight', cpos='NN', pos='NN', head=24, deprel='prep_by')
Token(index=32, form='the', cpos='DT', pos='DT', head=34, deprel='det')
Token(index=33, form='United', cpos='NNP', pos='NNP', head=34, deprel='nn')
Token(index=34, form='States', cpos='NNPS', pos='NNPS', head=30, deprel='prep_from')
Token(index=35, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()

    tree9 = '''(ROOT (S (NP (NP (DT A) (NN total)) (PP (IN of) (NP (NP
    (QP (CD 17) (CD million)) (JJ metric) (NNS tons)) (PP (IN of) (NP
    (NNS potatoes)))))) (VP (VBD was) (VP (VBN produced) (, ,) (SBAR (WHNP
    (WDT which)) (S (VP (VBD was) (ADJP (NP (CD 14) (NN %)) (JJR less)
    (PP (PP (IN than) (NP (NP (NP (JJ last) (NN year)) (PRN (-LRB- -LRB-)
    (NP (NP (CD 106) (NNS quintals)) (PP (IN per) (NP (NN hectare))))
    (-RRB- -RRB-))) (, ,) (CC and) (NP (NP (QP (CD 5.4) (CD million))
    (JJ metric) (NNS tons)) (PP (IN of) (NP (NNS vegetables)))))) (, ,)
    (CC or) (ADVP (NP (CD 2.2) (NN %)) (RBR more)) (PP (IN than) (PP (IN
    on) (NP (DT the) (JJ same) (NN date)) (NP (JJ last) (NN year))))))
    (PRN (-LRB- -LRB-) (NP (NP (JJ 116) (NNS quintals)) (PP (IN per)
    (NP (NN hectare)))) (-RRB- -RRB-))))))) (. .)))'''
    tree9_out = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='total', cpos='NN', pos='NN', head=11, deprel='nsubjpass')
Token(index=3, form='of', cpos='IN', pos='IN', head=2, deprel='prep')
Token(index=4, form='17', cpos='CD', pos='CD', head=5, deprel='number')
Token(index=5, form='million', cpos='CD', pos='CD', head=7, deprel='num')
Token(index=6, form='metric', cpos='JJ', pos='JJ', head=7, deprel='amod')
Token(index=7, form='tons', cpos='NNS', pos='NNS', head=3, deprel='pobj')
Token(index=8, form='of', cpos='IN', pos='IN', head=7, deprel='prep')
Token(index=9, form='potatoes', cpos='NNS', pos='NNS', head=8, deprel='pobj')
Token(index=10, form='was', cpos='VBD', pos='VBD', head=11, deprel='auxpass')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=0, deprel='root')
Token(index=12, form=',', cpos=',', pos=',', head=11, deprel='punct')
Token(index=13, form='which', cpos='WDT', pos='WDT', head=17, deprel='nsubj')
Token(index=14, form='was', cpos='VBD', pos='VBD', head=17, deprel='cop')
Token(index=15, form='14', cpos='CD', pos='CD', head=16, deprel='num')
Token(index=16, form='%', cpos='NN', pos='NN', head=17, deprel='npadvmod')
Token(index=17, form='less', cpos='JJR', pos='JJR', head=11, deprel='ccomp')
Token(index=18, form='than', cpos='IN', pos='IN', head=17, deprel='prep')
Token(index=19, form='last', cpos='JJ', pos='JJ', head=20, deprel='amod')
Token(index=20, form='year', cpos='NN', pos='NN', head=18, deprel='pobj')
Token(index=21, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=23, deprel='punct')
Token(index=22, form='106', cpos='CD', pos='CD', head=23, deprel='num')
Token(index=23, form='quintals', cpos='NNS', pos='NNS', head=20, deprel='dep')
Token(index=24, form='per', cpos='IN', pos='IN', head=23, deprel='prep')
Token(index=25, form='hectare', cpos='NN', pos='NN', head=24, deprel='pobj')
Token(index=26, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=23, deprel='punct')
Token(index=27, form=',', cpos=',', pos=',', head=20, deprel='punct')
Token(index=28, form='and', cpos='CC', pos='CC', head=20, deprel='cc')
Token(index=29, form='5.4', cpos='CD', pos='CD', head=30, deprel='number')
Token(index=30, form='million', cpos='CD', pos='CD', head=32, deprel='num')
Token(index=31, form='metric', cpos='JJ', pos='JJ', head=32, deprel='amod')
Token(index=32, form='tons', cpos='NNS', pos='NNS', head=20, deprel='conj')
Token(index=33, form='of', cpos='IN', pos='IN', head=32, deprel='prep')
Token(index=34, form='vegetables', cpos='NNS', pos='NNS', head=33, deprel='pobj')
Token(index=35, form=',', cpos=',', pos=',', head=18, deprel='punct')
Token(index=36, form='or', cpos='CC', pos='CC', head=18, deprel='cc')
Token(index=37, form='2.2', cpos='CD', pos='CD', head=38, deprel='num')
Token(index=38, form='%', cpos='NN', pos='NN', head=39, deprel='npadvmod')
Token(index=39, form='more', cpos='RBR', pos='RBR', head=18, deprel='conj')
Token(index=40, form='than', cpos='IN', pos='IN', head=18, deprel='conj')
Token(index=41, form='on', cpos='IN', pos='IN', head=40, deprel='pcomp')
Token(index=42, form='the', cpos='DT', pos='DT', head=44, deprel='det')
Token(index=43, form='same', cpos='JJ', pos='JJ', head=44, deprel='amod')
Token(index=44, form='date', cpos='NN', pos='NN', head=41, deprel='pobj')
Token(index=45, form='last', cpos='JJ', pos='JJ', head=46, deprel='amod')
Token(index=46, form='year', cpos='NN', pos='NN', head=41, deprel='tmod')
Token(index=47, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=49, deprel='punct')
Token(index=48, form='116', cpos='JJ', pos='JJ', head=49, deprel='amod')
Token(index=49, form='quintals', cpos='NNS', pos='NNS', head=17, deprel='dep')
Token(index=50, form='per', cpos='IN', pos='IN', head=49, deprel='prep')
Token(index=51, form='hectare', cpos='NN', pos='NN', head=50, deprel='pobj')
Token(index=52, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=49, deprel='punct')
Token(index=53, form='.', cpos='.', pos='.', head=11, deprel='punct')
    '''.strip()
    tree9_out_collapsed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='total', cpos='NN', pos='NN', head=11, deprel='nsubjpass')
Token(index=4, form='17', cpos='CD', pos='CD', head=5, deprel='number')
Token(index=5, form='million', cpos='CD', pos='CD', head=7, deprel='num')
Token(index=6, form='metric', cpos='JJ', pos='JJ', head=7, deprel='amod')
Token(index=7, form='tons', cpos='NNS', pos='NNS', head=2, deprel='prep_of')
Token(index=9, form='potatoes', cpos='NNS', pos='NNS', head=7, deprel='prep_of')
Token(index=10, form='was', cpos='VBD', pos='VBD', head=11, deprel='auxpass')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=0, deprel='root')
Token(index=12, form=',', cpos=',', pos=',', head=11, deprel='punct')
Token(index=13, form='which', cpos='WDT', pos='WDT', head=17, deprel='nsubj')
Token(index=14, form='was', cpos='VBD', pos='VBD', head=17, deprel='cop')
Token(index=15, form='14', cpos='CD', pos='CD', head=16, deprel='num')
Token(index=16, form='%', cpos='NN', pos='NN', head=17, deprel='npadvmod')
Token(index=17, form='less', cpos='JJR', pos='JJR', head=11, deprel='ccomp')
Token(index=19, form='last', cpos='JJ', pos='JJ', head=20, deprel='amod')
Token(index=20, form='year', cpos='NN', pos='NN', head=17, deprel='prep_than')
Token(index=21, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=23, deprel='punct')
Token(index=22, form='106', cpos='CD', pos='CD', head=23, deprel='num')
Token(index=23, form='quintals', cpos='NNS', pos='NNS', head=20, deprel='dep')
Token(index=25, form='hectare', cpos='NN', pos='NN', head=23, deprel='prep_per')
Token(index=26, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=23, deprel='punct')
Token(index=27, form=',', cpos=',', pos=',', head=20, deprel='punct')
Token(index=29, form='5.4', cpos='CD', pos='CD', head=30, deprel='number')
Token(index=30, form='million', cpos='CD', pos='CD', head=32, deprel='num')
Token(index=31, form='metric', cpos='JJ', pos='JJ', head=32, deprel='amod')
Token(index=32, form='tons', cpos='NNS', pos='NNS', head=20, deprel='conj_and')
Token(index=34, form='vegetables', cpos='NNS', pos='NNS', head=32, deprel='prep_of')
Token(index=35, form=',', cpos=',', pos=',', head=17, deprel='punct')
Token(index=37, form='2.2', cpos='CD', pos='CD', head=38, deprel='num')
Token(index=38, form='%', cpos='NN', pos='NN', head=39, deprel='npadvmod')
Token(index=39, form='more', cpos='RBR', pos='RBR', head=17, deprel='conj')
Token(index=41, form='on', cpos='IN', pos='IN', head=17, deprel='pcomp')
Token(index=42, form='the', cpos='DT', pos='DT', head=44, deprel='det')
Token(index=43, form='same', cpos='JJ', pos='JJ', head=44, deprel='amod')
Token(index=44, form='date', cpos='NN', pos='NN', head=41, deprel='pobj')
Token(index=45, form='last', cpos='JJ', pos='JJ', head=46, deprel='amod')
Token(index=46, form='year', cpos='NN', pos='NN', head=41, deprel='tmod')
Token(index=47, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=49, deprel='punct')
Token(index=48, form='116', cpos='JJ', pos='JJ', head=49, deprel='amod')
Token(index=49, form='quintals', cpos='NNS', pos='NNS', head=17, deprel='dep')
Token(index=51, form='hectare', cpos='NN', pos='NN', head=49, deprel='prep_per')
Token(index=52, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=49, deprel='punct')
Token(index=53, form='.', cpos='.', pos='.', head=11, deprel='punct')
    '''.strip()

    tree10 = r'''
(ROOT (NP (NP (NNP Hanoi) (, ,) (NNP May) (CD 13)) (PRN (-LRB- -LRB-) (NP (NNP VNA)) (-RRB- -RRB-)) (: --) (NP (NP (NNP Vietnam)) (SBAR (S (VP (VBZ has) (VP (VBN produced) (NP (NP (DT a) (NN variety)) (PP (IN of) (NP (NNS drugs)))) (S (VP (TO to) (VP (VB control) (NP (NNS HIV\/AIDS)) (PP (IN in) (NP (NP (NNS patients)) (VP (VBG suffering) (PP (IN with) (NP (DT the) (NN disease)))))))))))))) (. .)))
    '''.strip()
    tree10_out = '''
Token(index=1, form='Hanoi', cpos='NNP', pos='NNP', head=3, deprel='nn')
Token(index=2, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=3, form='May', cpos='NNP', pos='NNP', head=0, deprel='root')
Token(index=4, form='13', cpos='CD', pos='CD', head=3, deprel='num')
Token(index=5, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=6, deprel='punct')
Token(index=6, form='VNA', cpos='NNP', pos='NNP', head=3, deprel='appos')
Token(index=7, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=6, deprel='punct')
Token(index=8, form='--', cpos=':', pos=':', head=3, deprel='punct')
Token(index=9, form='Vietnam', cpos='NNP', pos='NNP', head=3, deprel='dep')
Token(index=10, form='has', cpos='VBZ', pos='VBZ', head=11, deprel='aux')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=9, deprel='rcmod')
Token(index=12, form='a', cpos='DT', pos='DT', head=13, deprel='det')
Token(index=13, form='variety', cpos='NN', pos='NN', head=11, deprel='dobj')
Token(index=14, form='of', cpos='IN', pos='IN', head=13, deprel='prep')
Token(index=15, form='drugs', cpos='NNS', pos='NNS', head=14, deprel='pobj')
Token(index=16, form='to', cpos='TO', pos='TO', head=17, deprel='aux')
Token(index=17, form='control', cpos='VB', pos='VB', head=11, deprel='vmod')
Token(index=18, form='HIV/AIDS', cpos='NNS', pos='NNS', head=17, deprel='dobj')
Token(index=19, form='in', cpos='IN', pos='IN', head=17, deprel='prep')
Token(index=20, form='patients', cpos='NNS', pos='NNS', head=19, deprel='pobj')
Token(index=21, form='suffering', cpos='VBG', pos='VBG', head=20, deprel='vmod')
Token(index=22, form='with', cpos='IN', pos='IN', head=21, deprel='prep')
Token(index=23, form='the', cpos='DT', pos='DT', head=24, deprel='det')
Token(index=24, form='disease', cpos='NN', pos='NN', head=22, deprel='pobj')
Token(index=25, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()
    tree10_out_collapsed = '''
Token(index=1, form='Hanoi', cpos='NNP', pos='NNP', head=3, deprel='nn')
Token(index=2, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=3, form='May', cpos='NNP', pos='NNP', head=0, deprel='root')
Token(index=4, form='13', cpos='CD', pos='CD', head=3, deprel='num')
Token(index=5, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=6, deprel='punct')
Token(index=6, form='VNA', cpos='NNP', pos='NNP', head=3, deprel='appos')
Token(index=7, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=6, deprel='punct')
Token(index=8, form='--', cpos=':', pos=':', head=3, deprel='punct')
Token(index=9, form='Vietnam', cpos='NNP', pos='NNP', head=3, deprel='dep')
Token(index=10, form='has', cpos='VBZ', pos='VBZ', head=11, deprel='aux')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=9, deprel='rcmod')
Token(index=12, form='a', cpos='DT', pos='DT', head=13, deprel='det')
Token(index=13, form='variety', cpos='NN', pos='NN', head=11, deprel='dobj')
Token(index=15, form='drugs', cpos='NNS', pos='NNS', head=13, deprel='prep_of')
Token(index=16, form='to', cpos='TO', pos='TO', head=17, deprel='aux')
Token(index=17, form='control', cpos='VB', pos='VB', head=11, deprel='vmod')
Token(index=18, form='HIV/AIDS', cpos='NNS', pos='NNS', head=17, deprel='dobj')
Token(index=20, form='patients', cpos='NNS', pos='NNS', head=17, deprel='prep_in')
Token(index=21, form='suffering', cpos='VBG', pos='VBG', head=20, deprel='vmod')
Token(index=23, form='the', cpos='DT', pos='DT', head=24, deprel='det')
Token(index=24, form='disease', cpos='NN', pos='NN', head=21, deprel='prep_with')
Token(index=25, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()

    @classmethod
    def get_basic_test_trees(self):
        return ((self.tree1, self.tree1_out),
                (self.tree2, self.tree2_out_basic),
                (self.tree3, self.tree3_out),
                (self.tree4, self.tree4_out_basic),
                (self.tree5, self.tree5_out_basic),
                (self.tree6, self.tree6_out),
                (self.tree7, self.tree7_out),
                (self.tree8, self.tree8_out),
                (self.tree9, self.tree9_out),
                (self.tree10, self.tree10_out))
    @classmethod
    def get_repr_test_trees(self):
        return ((self.tree2,
                 dict(basic=self.tree2_out_basic,
                      collapsed=self.tree2_out_collapsed,
                      CCprocessed=self.tree2_out_CCprocessed,
                      collapsedTree=self.tree2_out_collapsedTree)),
                (self.tree4,
                 dict(basic=self.tree4_out_basic,
                      collapsed=self.tree4_out_collapsed,
                      CCprocessed=self.tree4_out_CCprocessed,
                      collapsedTree=self.tree4_out_collapsedTree)),
                (self.tree5,
                 dict(basic=self.tree5_out_basic,
                      collapsed=self.tree5_out_collapsed,
                      CCprocessed=self.tree5_out_CCprocessed,
                      collapsedTree=self.tree5_out_collapsedTree)),
                (self.tree8, dict(collapsed=self.tree8_out_collapsed)),
                (self.tree9, dict(collapsed=self.tree9_out_collapsed)),
                (self.tree10, dict(collapsed=self.tree10_out_collapsed)))

# UD trees are similar to SD trees, but some parts are overridden
class trees_ud(trees_sd):
    tree2_out_collapsed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='cat', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='a', cpos='DT', pos='DT', head=5, deprel='det')
Token(index=5, form='mouse', cpos='NN', pos='NN', head=2, deprel='conj:and')
Token(index=6, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree2_out_collapsedTree = tree2_out_collapsed
    tree2_out_CCprocessed = tree2_out_collapsed

    tree4_out_basic = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=3, form='with', cpos='IN', pos='IN', head=4, deprel='case')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=2, deprel='nmod')
Token(index=5, form='but', cpos='CC', pos='CC', head=6, deprel='cc')
Token(index=6, form='not', cpos='RB', pos='RB', head=4, deprel='cc')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree4_out_collapsed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=3, form='with', cpos='IN', pos='IN', head=4, deprel='case')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=2, deprel='nmod:with')
Token(index=5, form='but', cpos='CC', pos='CC', head=6, deprel='cc')
Token(index=6, form='not', cpos='RB', pos='RB', head=4, deprel='cc')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj:negcc')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree4_out_CCprocessed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='burrito', cpos='NN', pos='NN', head=0, deprel='root')
Token(index=3, form='with', cpos='IN', pos='IN', head=4, deprel='case')
Token(index=4, form='beans', cpos='NNS', pos='NNS', head=2, deprel='nmod:with')
Token(index=5, form='but', cpos='CC', pos='CC', head=6, deprel='cc')
Token(index=6, form='not', cpos='RB', pos='RB', head=4, deprel='cc')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=2, deprel='nmod:with')
Token(index=7, form='chicken', cpos='NN', pos='NN', head=4, deprel='conj:negcc')
Token(index=8, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree4_out_collapsedTree = tree4_out_collapsed

    tree5_out_basic = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='nmod')
Token(index=8, form='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_collapsed = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj:and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='nmod:with')
Token(index=8, form='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj:negcc')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_CCprocessed = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=4, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj:and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='nmod:with')
Token(index=8, form='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', cpos='NN', pos='NN', head=5, deprel='nmod:with')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj:negcc')
Token(index=11, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()
    tree5_out_collapsedTree = tree5_out_collapsed

    tree5_out_collapsedTree_no_punct = '''
Token(index=1, form='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', cpos='VBZ', pos='VBZ', head=2, deprel='conj:and')
Token(index=5, form='burritos', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=7, form='beans', cpos='NNS', pos='NNS', head=5, deprel='nmod:with')
Token(index=8, form='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', cpos='NN', pos='NN', head=7, deprel='conj:negcc')
    '''.strip()

    # nothing gets erased in UD
    tree5_out_collapsedTree_erased = tree5_out_collapsedTree
    tree5_out_collapsedTree_erased_no_punct = tree5_out_collapsedTree_no_punct

    tree5_out_basic_lemmas = '''
Token(index=1, form='Ed', lemma='Ed', cpos='NNP', pos='NNP', head=2, deprel='nsubj')
Token(index=2, form='cooks', lemma='cook', cpos='VBZ', pos='VBZ', head=0, deprel='root')
Token(index=3, form='and', lemma='and', cpos='CC', pos='CC', head=2, deprel='cc')
Token(index=4, form='sells', lemma='sell', cpos='VBZ', pos='VBZ', head=2, deprel='conj')
Token(index=5, form='burritos', lemma='burrito', cpos='NNS', pos='NNS', head=2, deprel='dobj')
Token(index=6, form='with', lemma='with', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=7, form='beans', lemma='bean', cpos='NNS', pos='NNS', head=5, deprel='nmod')
Token(index=8, form='but', lemma='but', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=9, form='not', lemma='not', cpos='RB', pos='RB', head=7, deprel='cc')
Token(index=10, form='rice', lemma='rice', cpos='NN', pos='NN', head=7, deprel='conj')
Token(index=11, form='.', lemma='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()

    tree6_out = '''
Token(index=1, form='He', cpos='PRP', pos='PRP', head=6, deprel='nsubj')
Token(index=2, form='also', cpos='RB', pos='RB', head=6, deprel='advmod')
Token(index=3, form='is', cpos='VBZ', pos='VBZ', head=6, deprel='cop')
Token(index=4, form='a', cpos='DT', pos='DT', head=6, deprel='det')
Token(index=5, form='consensus', cpos='NN', pos='NN', head=6, deprel='compound')
Token(index=6, form='manager', cpos='NN', pos='NN', head=9, deprel='ccomp')
Token(index=7, form=',', cpos=',', pos=',', head=9, deprel='punct')
Token(index=8, form='insiders', cpos='NNS', pos='NNS', head=9, deprel='nsubj')
Token(index=9, form='say', cpos='VBP', pos='VBP', head=0, deprel='root')
Token(index=10, form='.', cpos='.', pos='.', head=9, deprel='punct')
'''.strip()

    tree7_out = '''
Token(index=1, form='PRIME', cpos='NNP', pos='NNP', head=2, deprel='compound')
Token(index=2, form='RATE', cpos='NNP', pos='NNP', head=0, deprel='root')
Token(index=3, form=':', cpos=':', pos=':', head=2, deprel='punct')
Token(index=4, form='10', cpos='CD', pos='CD', head=6, deprel='nummod')
Token(index=5, form='1/2', cpos='CD', pos='CD', head=6, deprel='nummod')
Token(index=6, form='%', cpos='NN', pos='NN', head=2, deprel='dep')
Token(index=7, form='.', cpos='.', pos='.', head=2, deprel='punct')
    '''.strip()

    tree8_out = '''
Token(index=1, form='Visitors', cpos='NNS', pos='NNS', head=3, deprel='nsubj')
Token(index=2, form='can', cpos='MD', pos='MD', head=3, deprel='aux')
Token(index=3, form='reach', cpos='VB', pos='VB', head=0, deprel='root')
Token(index=4, form='it', cpos='PRP', pos='PRP', head=3, deprel='dobj')
Token(index=5, form='only', cpos='RB', pos='RB', head=3, deprel='advmod')
Token(index=6, form='under', cpos='IN', pos='IN', head=9, deprel='case')
Token(index=7, form='strict', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=8, form='military', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=9, form='escort', cpos='NN', pos='NN', head=3, deprel='nmod')
Token(index=10, form='and', cpos='CC', pos='CC', head=9, deprel='cc')
Token(index=11, form='with', cpos='IN', pos='IN', head=13, deprel='case')
Token(index=12, form='prior', cpos='JJ', pos='JJ', head=13, deprel='amod')
Token(index=13, form='permission', cpos='NN', pos='NN', head=9, deprel='conj')
Token(index=14, form='from', cpos='IN', pos='IN', head=16, deprel='case')
Token(index=15, form='the', cpos='DT', pos='DT', head=16, deprel='det')
Token(index=16, form='Pentagon', cpos='NNP', pos='NNP', head=13, deprel='nmod')
Token(index=17, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=18, form='aboard', cpos='IN', pos='IN', head=22, deprel='case')
Token(index=19, form='special', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=20, form='small', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=21, form='shuttle', cpos='NN', pos='NN', head=22, deprel='compound')
Token(index=22, form='flights', cpos='NNS', pos='NNS', head=3, deprel='nmod')
Token(index=23, form='that', cpos='WDT', pos='WDT', head=24, deprel='nsubj')
Token(index=24, form='reach', cpos='VBP', pos='VBP', head=22, deprel='acl:relcl')
Token(index=25, form='the', cpos='DT', pos='DT', head=26, deprel='det')
Token(index=26, form='base', cpos='NN', pos='NN', head=24, deprel='dobj')
Token(index=27, form='by', cpos='IN', pos='IN', head=30, deprel='case')
Token(index=28, form='a', cpos='DT', pos='DT', head=30, deprel='det')
Token(index=29, form='circuitous', cpos='JJ', pos='JJ', head=30, deprel='amod')
Token(index=30, form='flight', cpos='NN', pos='NN', head=24, deprel='nmod')
Token(index=31, form='from', cpos='IN', pos='IN', head=34, deprel='case')
Token(index=32, form='the', cpos='DT', pos='DT', head=34, deprel='det')
Token(index=33, form='United', cpos='NNP', pos='NNP', head=34, deprel='compound')
Token(index=34, form='States', cpos='NNPS', pos='NNPS', head=30, deprel='nmod')
Token(index=35, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()
    tree8_out_collapsed = '''
Token(index=1, form='Visitors', cpos='NNS', pos='NNS', head=3, deprel='nsubj')
Token(index=2, form='can', cpos='MD', pos='MD', head=3, deprel='aux')
Token(index=3, form='reach', cpos='VB', pos='VB', head=0, deprel='root')
Token(index=3, form='reach', cpos='VB', pos='VB', head=3, deprel='conj:and', extra={'dep_is_copy': 1})
Token(index=4, form='it', cpos='PRP', pos='PRP', head=3, deprel='dobj')
Token(index=5, form='only', cpos='RB', pos='RB', head=3, deprel='advmod')
Token(index=6, form='under', cpos='IN', pos='IN', head=9, deprel='case')
Token(index=7, form='strict', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=8, form='military', cpos='JJ', pos='JJ', head=9, deprel='amod')
Token(index=9, form='escort', cpos='NN', pos='NN', head=3, deprel='nmod:under')
Token(index=10, form='and', cpos='CC', pos='CC', head=3, deprel='cc')
Token(index=11, form='with', cpos='IN', pos='IN', head=13, deprel='case')
Token(index=12, form='prior', cpos='JJ', pos='JJ', head=13, deprel='amod')
Token(index=13, form='permission', cpos='NN', pos='NN', head=3, deprel='nmod:with', extra={'gov_is_copy': 1})
Token(index=14, form='from', cpos='IN', pos='IN', head=16, deprel='case')
Token(index=15, form='the', cpos='DT', pos='DT', head=16, deprel='det')
Token(index=16, form='Pentagon', cpos='NNP', pos='NNP', head=13, deprel='nmod:from')
Token(index=17, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=18, form='aboard', cpos='IN', pos='IN', head=22, deprel='case')
Token(index=19, form='special', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=20, form='small', cpos='JJ', pos='JJ', head=22, deprel='amod')
Token(index=21, form='shuttle', cpos='NN', pos='NN', head=22, deprel='compound')
Token(index=22, form='flights', cpos='NNS', pos='NNS', head=3, deprel='nmod:aboard')
Token(index=22, form='flights', cpos='NNS', pos='NNS', head=24, deprel='nsubj')
Token(index=23, form='that', cpos='WDT', pos='WDT', head=22, deprel='ref')
Token(index=24, form='reach', cpos='VBP', pos='VBP', head=22, deprel='acl:relcl')
Token(index=25, form='the', cpos='DT', pos='DT', head=26, deprel='det')
Token(index=26, form='base', cpos='NN', pos='NN', head=24, deprel='dobj')
Token(index=27, form='by', cpos='IN', pos='IN', head=30, deprel='case')
Token(index=28, form='a', cpos='DT', pos='DT', head=30, deprel='det')
Token(index=29, form='circuitous', cpos='JJ', pos='JJ', head=30, deprel='amod')
Token(index=30, form='flight', cpos='NN', pos='NN', head=24, deprel='nmod:by')
Token(index=31, form='from', cpos='IN', pos='IN', head=34, deprel='case')
Token(index=32, form='the', cpos='DT', pos='DT', head=34, deprel='det')
Token(index=33, form='United', cpos='NNP', pos='NNP', head=34, deprel='compound')
Token(index=34, form='States', cpos='NNPS', pos='NNPS', head=30, deprel='nmod:from')
Token(index=35, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()
    tree9_out = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='total', cpos='NN', pos='NN', head=11, deprel='nsubjpass')
Token(index=3, form='of', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=4, form='17', cpos='CD', pos='CD', head=5, deprel='compound')
Token(index=5, form='million', cpos='CD', pos='CD', head=7, deprel='nummod')
Token(index=6, form='metric', cpos='JJ', pos='JJ', head=7, deprel='amod')
Token(index=7, form='tons', cpos='NNS', pos='NNS', head=2, deprel='nmod')
Token(index=8, form='of', cpos='IN', pos='IN', head=9, deprel='case')
Token(index=9, form='potatoes', cpos='NNS', pos='NNS', head=7, deprel='nmod')
Token(index=10, form='was', cpos='VBD', pos='VBD', head=11, deprel='auxpass')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=0, deprel='root')
Token(index=12, form=',', cpos=',', pos=',', head=11, deprel='punct')
Token(index=13, form='which', cpos='WDT', pos='WDT', head=17, deprel='nsubj')
Token(index=14, form='was', cpos='VBD', pos='VBD', head=17, deprel='cop')
Token(index=15, form='14', cpos='CD', pos='CD', head=16, deprel='nummod')
Token(index=16, form='%', cpos='NN', pos='NN', head=17, deprel='nmod:npmod')
Token(index=17, form='less', cpos='JJR', pos='JJR', head=11, deprel='ccomp')
Token(index=18, form='than', cpos='IN', pos='IN', head=20, deprel='case')
Token(index=19, form='last', cpos='JJ', pos='JJ', head=20, deprel='amod')
Token(index=20, form='year', cpos='NN', pos='NN', head=17, deprel='nmod')
Token(index=21, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=23, deprel='punct')
Token(index=22, form='106', cpos='CD', pos='CD', head=23, deprel='nummod')
Token(index=23, form='quintals', cpos='NNS', pos='NNS', head=20, deprel='dep')
Token(index=24, form='per', cpos='IN', pos='IN', head=25, deprel='case')
Token(index=25, form='hectare', cpos='NN', pos='NN', head=23, deprel='nmod')
Token(index=26, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=23, deprel='punct')
Token(index=27, form=',', cpos=',', pos=',', head=20, deprel='punct')
Token(index=28, form='and', cpos='CC', pos='CC', head=20, deprel='cc')
Token(index=29, form='5.4', cpos='CD', pos='CD', head=30, deprel='compound')
Token(index=30, form='million', cpos='CD', pos='CD', head=32, deprel='nummod')
Token(index=31, form='metric', cpos='JJ', pos='JJ', head=32, deprel='amod')
Token(index=32, form='tons', cpos='NNS', pos='NNS', head=20, deprel='conj')
Token(index=33, form='of', cpos='IN', pos='IN', head=34, deprel='case')
Token(index=34, form='vegetables', cpos='NNS', pos='NNS', head=32, deprel='nmod')
Token(index=35, form=',', cpos=',', pos=',', head=20, deprel='punct')
Token(index=36, form='or', cpos='CC', pos='CC', head=20, deprel='cc')
Token(index=37, form='2.2', cpos='CD', pos='CD', head=38, deprel='nummod')
Token(index=38, form='%', cpos='NN', pos='NN', head=39, deprel='nmod:npmod')
Token(index=39, form='more', cpos='RBR', pos='RBR', head=20, deprel='conj')
Token(index=40, form='than', cpos='IN', pos='IN', head=44, deprel='case')
Token(index=41, form='on', cpos='IN', pos='IN', head=44, deprel='case')
Token(index=42, form='the', cpos='DT', pos='DT', head=44, deprel='det')
Token(index=43, form='same', cpos='JJ', pos='JJ', head=44, deprel='amod')
Token(index=44, form='date', cpos='NN', pos='NN', head=20, deprel='conj')
Token(index=45, form='last', cpos='JJ', pos='JJ', head=46, deprel='amod')
Token(index=46, form='year', cpos='NN', pos='NN', head=44, deprel='nmod:tmod')
Token(index=47, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=49, deprel='punct')
Token(index=48, form='116', cpos='JJ', pos='JJ', head=49, deprel='amod')
Token(index=49, form='quintals', cpos='NNS', pos='NNS', head=17, deprel='dep')
Token(index=50, form='per', cpos='IN', pos='IN', head=51, deprel='case')
Token(index=51, form='hectare', cpos='NN', pos='NN', head=49, deprel='nmod')
Token(index=52, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=49, deprel='punct')
Token(index=53, form='.', cpos='.', pos='.', head=11, deprel='punct')
    '''.strip()
    tree9_out_collapsed = '''
Token(index=1, form='A', cpos='DT', pos='DT', head=2, deprel='det')
Token(index=2, form='total', cpos='NN', pos='NN', head=11, deprel='nsubjpass')
Token(index=3, form='of', cpos='IN', pos='IN', head=7, deprel='case')
Token(index=4, form='17', cpos='CD', pos='CD', head=5, deprel='compound')
Token(index=5, form='million', cpos='CD', pos='CD', head=7, deprel='nummod')
Token(index=6, form='metric', cpos='JJ', pos='JJ', head=7, deprel='amod')
Token(index=7, form='tons', cpos='NNS', pos='NNS', head=2, deprel='nmod:of')
Token(index=8, form='of', cpos='IN', pos='IN', head=9, deprel='case')
Token(index=9, form='potatoes', cpos='NNS', pos='NNS', head=7, deprel='nmod:of')
Token(index=10, form='was', cpos='VBD', pos='VBD', head=11, deprel='auxpass')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=0, deprel='root')
Token(index=12, form=',', cpos=',', pos=',', head=11, deprel='punct')
Token(index=13, form='which', cpos='WDT', pos='WDT', head=17, deprel='nsubj')
Token(index=14, form='was', cpos='VBD', pos='VBD', head=17, deprel='cop')
Token(index=15, form='14', cpos='CD', pos='CD', head=16, deprel='nummod')
Token(index=16, form='%', cpos='NN', pos='NN', head=17, deprel='nmod:npmod')
Token(index=17, form='less', cpos='JJR', pos='JJR', head=11, deprel='ccomp')
Token(index=17, form='less', cpos='JJR', pos='JJR', head=17, deprel='conj:and', extra={'dep_is_copy': 3})
Token(index=17, form='less', cpos='JJR', pos='JJR', head=17, deprel='conj:and', extra={'dep_is_copy': 4})
Token(index=17, form='less', cpos='JJR', pos='JJR', head=17, deprel='conj:or', extra={'dep_is_copy': 1})
Token(index=17, form='less', cpos='JJR', pos='JJR', head=17, deprel='conj:or', extra={'dep_is_copy': 2})
Token(index=18, form='than', cpos='IN', pos='IN', head=20, deprel='case')
Token(index=19, form='last', cpos='JJ', pos='JJ', head=20, deprel='amod')
Token(index=20, form='year', cpos='NN', pos='NN', head=17, deprel='nmod:than')
Token(index=21, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=23, deprel='punct')
Token(index=22, form='106', cpos='CD', pos='CD', head=23, deprel='nummod')
Token(index=23, form='quintals', cpos='NNS', pos='NNS', head=20, deprel='dep')
Token(index=24, form='per', cpos='IN', pos='IN', head=25, deprel='case')
Token(index=25, form='hectare', cpos='NN', pos='NN', head=23, deprel='nmod:per')
Token(index=26, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=23, deprel='punct')
Token(index=27, form=',', cpos=',', pos=',', head=20, deprel='punct')
Token(index=28, form='and', cpos='CC', pos='CC', head=17, deprel='cc')
Token(index=29, form='5.4', cpos='CD', pos='CD', head=30, deprel='compound')
Token(index=30, form='million', cpos='CD', pos='CD', head=32, deprel='nummod')
Token(index=31, form='metric', cpos='JJ', pos='JJ', head=32, deprel='amod')
Token(index=32, form='tons', cpos='NNS', pos='NNS', head=20, deprel='conj')
Token(index=33, form='of', cpos='IN', pos='IN', head=34, deprel='case')
Token(index=34, form='vegetables', cpos='NNS', pos='NNS', head=32, deprel='nmod:of')
Token(index=35, form=',', cpos=',', pos=',', head=20, deprel='punct')
Token(index=36, form='or', cpos='CC', pos='CC', head=17, deprel='cc')
Token(index=37, form='2.2', cpos='CD', pos='CD', head=38, deprel='nummod')
Token(index=38, form='%', cpos='NN', pos='NN', head=39, deprel='nmod:npmod')
Token(index=39, form='more', cpos='RBR', pos='RBR', head=20, deprel='conj')
Token(index=40, form='than', cpos='IN', pos='IN', head=44, deprel='case')
Token(index=41, form='on', cpos='IN', pos='IN', head=44, deprel='case')
Token(index=42, form='the', cpos='DT', pos='DT', head=44, deprel='det')
Token(index=43, form='same', cpos='JJ', pos='JJ', head=44, deprel='amod')
Token(index=44, form='date', cpos='NN', pos='NN', head=17, deprel='nmod:on', extra={'gov_is_copy': 1})
Token(index=45, form='last', cpos='JJ', pos='JJ', head=46, deprel='amod')
Token(index=46, form='year', cpos='NN', pos='NN', head=44, deprel='nmod:tmod')
Token(index=47, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=49, deprel='punct')
Token(index=48, form='116', cpos='JJ', pos='JJ', head=49, deprel='amod')
Token(index=49, form='quintals', cpos='NNS', pos='NNS', head=17, deprel='dep')
Token(index=50, form='per', cpos='IN', pos='IN', head=51, deprel='case')
Token(index=51, form='hectare', cpos='NN', pos='NN', head=49, deprel='nmod:per')
Token(index=52, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=49, deprel='punct')
Token(index=53, form='.', cpos='.', pos='.', head=11, deprel='punct')
    '''.strip()

    tree10_out = '''
Token(index=1, form='Hanoi', cpos='NNP', pos='NNP', head=3, deprel='compound')
Token(index=2, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=3, form='May', cpos='NNP', pos='NNP', head=0, deprel='root')
Token(index=4, form='13', cpos='CD', pos='CD', head=3, deprel='nummod')
Token(index=5, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=6, deprel='punct')
Token(index=6, form='VNA', cpos='NNP', pos='NNP', head=3, deprel='appos')
Token(index=7, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=6, deprel='punct')
Token(index=8, form='--', cpos=':', pos=':', head=3, deprel='punct')
Token(index=9, form='Vietnam', cpos='NNP', pos='NNP', head=3, deprel='dep')
Token(index=10, form='has', cpos='VBZ', pos='VBZ', head=11, deprel='aux')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=9, deprel='acl:relcl')
Token(index=12, form='a', cpos='DT', pos='DT', head=13, deprel='det')
Token(index=13, form='variety', cpos='NN', pos='NN', head=11, deprel='dobj')
Token(index=14, form='of', cpos='IN', pos='IN', head=15, deprel='case')
Token(index=15, form='drugs', cpos='NNS', pos='NNS', head=13, deprel='nmod')
Token(index=16, form='to', cpos='TO', pos='TO', head=17, deprel='mark')
Token(index=17, form='control', cpos='VB', pos='VB', head=11, deprel='advcl')
Token(index=18, form='HIV/AIDS', cpos='NNS', pos='NNS', head=17, deprel='dobj')
Token(index=19, form='in', cpos='IN', pos='IN', head=20, deprel='case')
Token(index=20, form='patients', cpos='NNS', pos='NNS', head=17, deprel='nmod')
Token(index=21, form='suffering', cpos='VBG', pos='VBG', head=20, deprel='acl')
Token(index=22, form='with', cpos='IN', pos='IN', head=24, deprel='case')
Token(index=23, form='the', cpos='DT', pos='DT', head=24, deprel='det')
Token(index=24, form='disease', cpos='NN', pos='NN', head=21, deprel='nmod')
Token(index=25, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()
    tree10_out_collapsed = '''
Token(index=1, form='Hanoi', cpos='NNP', pos='NNP', head=3, deprel='compound')
Token(index=2, form=',', cpos=',', pos=',', head=3, deprel='punct')
Token(index=3, form='May', cpos='NNP', pos='NNP', head=0, deprel='root')
Token(index=4, form='13', cpos='CD', pos='CD', head=3, deprel='nummod')
Token(index=5, form='-LRB-', cpos='-LRB-', pos='-LRB-', head=6, deprel='punct')
Token(index=6, form='VNA', cpos='NNP', pos='NNP', head=3, deprel='appos')
Token(index=7, form='-RRB-', cpos='-RRB-', pos='-RRB-', head=6, deprel='punct')
Token(index=8, form='--', cpos=':', pos=':', head=3, deprel='punct')
Token(index=9, form='Vietnam', cpos='NNP', pos='NNP', head=3, deprel='dep')
Token(index=10, form='has', cpos='VBZ', pos='VBZ', head=11, deprel='aux')
Token(index=11, form='produced', cpos='VBN', pos='VBN', head=9, deprel='acl:relcl')
Token(index=12, form='a', cpos='DT', pos='DT', head=13, deprel='det')
Token(index=13, form='variety', cpos='NN', pos='NN', head=11, deprel='dobj')
Token(index=14, form='of', cpos='IN', pos='IN', head=15, deprel='case')
Token(index=15, form='drugs', cpos='NNS', pos='NNS', head=13, deprel='nmod:of')
Token(index=16, form='to', cpos='TO', pos='TO', head=17, deprel='mark')
Token(index=17, form='control', cpos='VB', pos='VB', head=11, deprel='advcl')
Token(index=18, form='HIV/AIDS', cpos='NNS', pos='NNS', head=17, deprel='dobj')
Token(index=19, form='in', cpos='IN', pos='IN', head=20, deprel='case')
Token(index=20, form='patients', cpos='NNS', pos='NNS', head=17, deprel='nmod:in')
Token(index=21, form='suffering', cpos='VBG', pos='VBG', head=20, deprel='acl')
Token(index=22, form='with', cpos='IN', pos='IN', head=24, deprel='case')
Token(index=23, form='the', cpos='DT', pos='DT', head=24, deprel='det')
Token(index=24, form='disease', cpos='NN', pos='NN', head=21, deprel='nmod:with')
Token(index=25, form='.', cpos='.', pos='.', head=3, deprel='punct')
    '''.strip()
